import { J as Json, O as ObjectStorage, L as LogHandlerOptions, cW as LogMessage, a as LogHandler } from './uuid-3a41b2e1.js';
export { dw as ArgumentsType, co as AsyncMutex, cJ as AsyncReturnType, Y as BinInput, d as CRYPTO_DEFAULT_ALG, e as CRYPTO_DEFAULT_DERIVE_ALG, f as CRYPTO_DEFAULT_DERIVE_ITERATIONS, C as CRYPTO_DEFAULT_HASH_ALG, d4 as Channel, d3 as ChannelMessageEvent, di as CryptoEncoder, aw as DAY_MS, aT as Day, ay as DayInput, aS as DayInputLegacy, ax as DayValue, aZ as DecimalInput, aY as DecimalValue, da as DefaultListener, ce as Disposable, cd as Disposer, cc as DisposerFunction, db as Emitter, d8 as EmitterAllHandler, d7 as EmitterHandler, df as Encoder, J as Json, dh as JsonEncoder, d9 as ListenerSignature, d5 as LocalChannel, a as LogHandler, L as LogHandlerOptions, cT as LogLevel, cU as LogLevelAlias, cV as LogLevelAliasKey, b as LogLevelAliasType, cW as LogMessage, cS as Logger, cZ as LoggerConsoleHandler, cY as LoggerContext, cX as LoggerContextInterface, c as LoggerInterface, d2 as LoggerMemoryHandler, dS as MemStorage, dR as MemStorageOptions, dl as Message, dj as MessageAction, dq as MessageDefinitions, dr as MessageHub, dk as MessageResult, dn as MessagesDefaultMethods, dp as MessagesMethods, dm as MessagesOptions, cn as Mutex, dW as NestedArray, dg as NoopEncoder, O as ObjectStorage, cx as Pool, ct as PoolTask, cv as PoolTaskEvents, cr as PoolTaskFn, cu as PoolTaskIdConflictResolution, cs as PoolTaskState, b7 as Primitive, du as PubSub, dz as RPCFn, dy as RPCOptions, dA as RPCReturn, as as RenderMessagesOptions, dx as ReturnType, bG as RoundingMode, cM as SerialQueue, bR as SortableItem, cL as TaskEvents, cK as TaskFn, ac as Uint8ArrayToHexDump, ab as Uint8ArrayToJson, a0 as Uint8ArrayToString, cj as UseDefer, cg as UseDispose, cb as XRX, Z as _decodeUtf8Polyfill, _ as _encodeUtf8Polyfill, I as arrayAvg, K as arrayBatches, w as arrayEmptyInPlace, u as arrayFilterInPlace, o as arrayFlatten, p as arrayIntersection, z as arrayIsEqual, F as arrayMax, G as arrayMin, m as arrayMinus, E as arrayRandomElement, s as arrayRemoveElement, t as arraySetElement, B as arrayShuffle, D as arrayShuffleForce, A as arrayShuffleInPlace, x as arraySorted, y as arraySortedNumbers, H as arraySum, q as arraySymmetricDifference, v as arrayToggleInPlace, n as arrayUnion, l as arrayUnique, bt as avg, br as between, c5 as cloneJsonObject, c4 as cloneObject, bC as cmp, bB as composeOrderby, M as createArray, d6 as createLocalChannelPair, cy as createPromise, ds as createPromiseProxy, k as csv, aX as dateStringToDays, aW as day, aB as dayDay, aR as dayDiff, aF as dayFromAny, aH as dayFromDate, aI as dayFromDateGMT, aM as dayFromParts, aN as dayFromString, aK as dayFromTimestamp, aE as dayFromToday, aA as dayMonth, aO as dayMonthStart, aQ as dayOffset, aD as dayToDate, aG as dayToDateGMT, aC as dayToParts, aL as dayToString, aJ as dayToTimestamp, az as dayYear, aP as dayYearStart, cO as debounce, a_ as decimal, b1 as decimalCentsPart, a$ as decimalFromCents, b0 as decimalToCents, S as decodeBase16, P as decodeBase32, U as decodeBase58, W as decodeBase62, j as decrypt, b2 as deepEqual, b4 as deepMerge, b3 as deepStripUndefinedInPlace, h as deriveKeyPbkdf2, dN as detect, g as digest, c3 as empty, R as encodeBase16, N as encodeBase32, T as encodeBase58, V as encodeBase62, bZ as encodeQuery, i as encrypt, bT as endSortWeight, b$ as ensureKey, c0 as ensureKeyAsync, a9 as equalBinary, b5 as escapeHTML, bF as escapeRegExp, X as estimateSizeForBase, dE as fetchBasic, dF as fetchJson, dJ as fetchOptionsBasicAuth, dH as fetchOptionsFormURLEncoded, dI as fetchOptionsJson, dG as fetchText, av as fixBrokenUth8String, aU as forEachDay, c8 as forTimes, at as formatMessages, dU as formatMilliseconds, a7 as fromBase64, a8 as fromBase64String, ag as fromCamelCase, a4 as fromHex, dM as getGlobal, cP as getGlobalContext, dc as getGlobalEmitter, cR as getGlobalLogger, c_ as getNamespaceFilterString, dL as getNavigator, bm as getSecureRandom, bn as getSecureRandomIfPossible, dT as getTimestamp, dK as getWindow, dC as httpMethod, cA as immediate, ba as isArray, bg as isBoolean, dO as isBrowser, bI as isEven, bH as isHalf, be as isInteger, cQ as isLocalHost, bh as isNullOrUndefined, bd as isNumber, b8 as isObject, bv as isPrime, bu as isPrimeRX, b9 as isPrimitive, cH as isPromise, bb as isRecord, bf as isSafeInteger, bc as isString, cE as isTimeout, bi as isUint8Array, a2 as joinToUint8Array, bl as jsonStringify, bk as jsonStringifySafe, bj as jsonStringifySorted, aa as jsonToUint8Array, c2 as last, de as lazyListener, bX as linkifyPlainText, c6 as memoize, c7 as memoizeAsync, dd as messages, bU as moveSortWeight, bz as objectIsEmpty, bx as objectMap, by as objectMergeDisposable, dD as parseBasicAuth, dV as parseDate, d0 as parseLogLevel, bA as parseOrderby, b_ as parseQuery, dP as platform, cI as promisify, eg as qid, bo as randomBoolean, bq as randomFloat, bp as randomInt, r as randomUint8Array, ca as regExpEscape, c9 as regExpString, au as renderMessages, bK as roundDown, bN as roundHalfAwayFromZero, bO as roundHalfDown, bP as roundHalfEven, bM as roundHalfOdd, bQ as roundHalfTowardsZero, bL as roundHalfUp, bJ as roundUp, bw as seededRandom, ea as setUuidDefaultEncoding, c1 as size, cz as sleep, bV as sortedItems, bD as sortedOrderby, bS as startSortWeight, ah as stringToBoolean, aj as stringToFloat, ai as stringToInteger, $ as stringToUInt8Array, e6 as suid, e5 as suidBytes, e8 as suidBytesDate, e7 as suidDate, bs as sum, cN as throttle, cC as timeout, cB as timeoutReached, cD as timoutError, a5 as toBase64, a6 as toBase64Url, ar as toBool, ad as toCamelCase, ae as toCapitalize, af as toCapitalizeWords, ao as toFloat, a3 as toHex, bY as toHumanReadableUrl, ap as toInt, aq as toString, a1 as toUint8Array, bE as toValidFilename, aV as today, cF as tryTimeout, ef as uname, b6 as unescapeHTML, cq as useAsyncMutex, Q as useBase, ci as useDefer, cf as useDispose, ch as useDisposer, cm as useEventListener, dQ as useExitHandler, cl as useInterval, d1 as useLevelFilter, dt as useMessageHub, cp as useMutex, c$ as useNamespaceFilter, cw as usePool, dv as usePubSub, dB as useRPC, bW as useSorted, ck as useTimeout, eb as uuid, e9 as uuid32bit, d$ as uuidB32, dY as uuidB62, dX as uuidBytes, ec as uuidDecode, e1 as uuidDecodeB32, d_ as uuidDecodeB62, e4 as uuidDecodeV4, ed as uuidEncode, e0 as uuidEncodeB32, dZ as uuidEncodeB62, e3 as uuidEncodeV4, ee as uuidIsValid, e2 as uuidv4, ak as valueToBoolean, am as valueToFloat, al as valueToInteger, an as valueToString, cG as waitOn } from './uuid-3a41b2e1.js';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

interface csvOptions {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
}
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: csvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): any[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

export { FileStorage, FileStorageOptions, LoggerFileHandler, LoggerNodeHandler, colorString, colorStringList, ensureFolder, exists, getEnvVariableRelaxed, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, stringToPath, toHumanReadableFilePath, toPath, valueToPath, writeText };
